package problem2;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class MainFrame extends JFrame {
	int inputFileState=0;
	int outputFileState=0;
	File inputFile;
	File outputFile;
	JTextField inputFileText=new JTextField("̓t@C");
	JTextField outputFileText=new JTextField("o̓t@C");
	JButton inputFileSetter=new JButton("Q");
	JButton outputFileSetter=new JButton("Q");
	JButton start=new JButton("s");
	public MainFrame(){
		this.setLayout(new GridLayout(3,3));
		//add
		inputFileText.setEnabled(false);
		outputFileText.setEnabled(false);
		start.setEnabled(false);
		Container container=this.getContentPane();
		container.add(new JLabel("̓t@C"));
		container.add(inputFileText);
		container.add(inputFileSetter);
		container.add(new JLabel("o̓t@C"));
		container.add(outputFileText);
		container.add(outputFileSetter);
		container.add(new JLabel(""));
		container.add(start);
		container.add(new JLabel(""));
		//setting
		this.setLocationRelativeTo(null);
		this.setTitle("ۑ1");
		this.pack();
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		//listener
		inputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					inputFile=fileChooser.getSelectedFile();
					inputFileText.setText(inputFile.getAbsolutePath());
					inputFileState=1;
					if(outputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		outputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("o̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					outputFile=fileChooser.getSelectedFile();
					outputFileText.setText(outputFile.getAbsolutePath());
					outputFileState=1;
					if(inputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		start.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					//input-output open
					FileReader reader=new FileReader(inputFile);
					BufferedReader input=new BufferedReader(reader);
					outputFile.createNewFile();
					FileWriter writer=new FileWriter(outputFile);
					BufferedWriter output=new BufferedWriter(writer);
					//calculate
					String line;
					int day[]=new int[100];
					//read N,Q
					line=input.readLine();
					String part[]=line.split(" ");
					int number=Integer.parseInt(part[0]);
					int quorum=Integer.parseInt(part[1]);
					while((number!=0)&&(quorum!=0)){
						//intialize date
						for(int i=0;i<100;i++){
							day[i]=0;
						}
						//read M,D
						for(int i=0;i<number;i++){
							line=input.readLine();
							String date[]=line.split(" ");
							for(int j=0;j<Integer.parseInt(date[0]);j++){
								day[Integer.parseInt(date[j+1])]++;
							}
						}
						//decide date
						int decition=0;
						for(int i=1;i<100;i++){
							if((day[decition]<day[i])&&(day[i]>=quorum)){
								decition=i;
							}
						}
						//write
						output.write(Integer.toString(decition));
						output.newLine();
						output.flush();
						//read Next N,Q
						line=input.readLine();
						part=line.split(" ");
						number=Integer.parseInt(part[0]);
						quorum=Integer.parseInt(part[1]);
					}
					//input-output close				
					input.close();
					output.close();
					JOptionPane.showMessageDialog(null,"I܂B");
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		});
	}
}
